/**
 * Document Understanding API
 * Document AI helps customers perform various analysis on their documents. If a customer has lots of documents, they can process them in batch using asynchronous API endpoints.
 * OpenAPI spec version: 20221109
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as ActionType from "./action-type";
export import ActionType = ActionType.ActionType;
import * as AddModelLockDetails from "./add-model-lock-details";
export import AddModelLockDetails = AddModelLockDetails.AddModelLockDetails;
import * as AddProjectLockDetails from "./add-project-lock-details";
export import AddProjectLockDetails = AddProjectLockDetails.AddProjectLockDetails;
import * as AnalyzeDocumentDetails from "./analyze-document-details";
export import AnalyzeDocumentDetails = AnalyzeDocumentDetails.AnalyzeDocumentDetails;
import * as AnalyzeDocumentResult from "./analyze-document-result";
export import AnalyzeDocumentResult = AnalyzeDocumentResult.AnalyzeDocumentResult;
import * as BarCode from "./bar-code";
export import BarCode = BarCode.BarCode;
import * as BoundingPolygon from "./bounding-polygon";
export import BoundingPolygon = BoundingPolygon.BoundingPolygon;
import * as Capabilities from "./capabilities";
export import Capabilities = Capabilities.Capabilities;
import * as Capability from "./capability";
export import Capability = Capability.Capability;
import * as Cell from "./cell";
export import Cell = Cell.Cell;
import * as ChangeModelCompartmentDetails from "./change-model-compartment-details";
export import ChangeModelCompartmentDetails = ChangeModelCompartmentDetails.ChangeModelCompartmentDetails;
import * as ChangeProjectCompartmentDetails from "./change-project-compartment-details";
export import ChangeProjectCompartmentDetails = ChangeProjectCompartmentDetails.ChangeProjectCompartmentDetails;
import * as ComponentModel from "./component-model";
export import ComponentModel = ComponentModel.ComponentModel;
import * as CreateModelDetails from "./create-model-details";
export import CreateModelDetails = CreateModelDetails.CreateModelDetails;
import * as CreateProcessorJobDetails from "./create-processor-job-details";
export import CreateProcessorJobDetails = CreateProcessorJobDetails.CreateProcessorJobDetails;
import * as CreateProjectDetails from "./create-project-details";
export import CreateProjectDetails = CreateProjectDetails.CreateProjectDetails;
import * as Dataset from "./dataset";
export import Dataset = Dataset.Dataset;
import * as DatasetSummary from "./dataset-summary";
export import DatasetSummary = DatasetSummary.DatasetSummary;
import * as DetectedDocumentType from "./detected-document-type";
export import DetectedDocumentType = DetectedDocumentType.DetectedDocumentType;
import * as DetectedLanguage from "./detected-language";
export import DetectedLanguage = DetectedLanguage.DetectedLanguage;
import * as Dimensions from "./dimensions";
export import Dimensions = Dimensions.Dimensions;
import * as DocumentClassificationConfidenceEntry from "./document-classification-confidence-entry";
export import DocumentClassificationConfidenceEntry = DocumentClassificationConfidenceEntry.DocumentClassificationConfidenceEntry;
import * as DocumentClassificationLabelMetricsReport from "./document-classification-label-metrics-report";
export import DocumentClassificationLabelMetricsReport = DocumentClassificationLabelMetricsReport.DocumentClassificationLabelMetricsReport;
import * as DocumentClassificationOverallMetricsReport from "./document-classification-overall-metrics-report";
export import DocumentClassificationOverallMetricsReport = DocumentClassificationOverallMetricsReport.DocumentClassificationOverallMetricsReport;
import * as DocumentDetails from "./document-details";
export import DocumentDetails = DocumentDetails.DocumentDetails;
import * as DocumentFeature from "./document-feature";
export import DocumentFeature = DocumentFeature.DocumentFeature;
import * as DocumentField from "./document-field";
export import DocumentField = DocumentField.DocumentField;
import * as DocumentMetadata from "./document-metadata";
export import DocumentMetadata = DocumentMetadata.DocumentMetadata;
import * as DocumentType from "./document-type";
export import DocumentType = DocumentType.DocumentType;
import * as DrivingLicenseKvModelSubTypeDetails from "./driving-license-kv-model-sub-type-details";
export import DrivingLicenseKvModelSubTypeDetails = DrivingLicenseKvModelSubTypeDetails.DrivingLicenseKvModelSubTypeDetails;
import * as FieldLabel from "./field-label";
export import FieldLabel = FieldLabel.FieldLabel;
import * as FieldName from "./field-name";
export import FieldName = FieldName.FieldName;
import * as FieldValue from "./field-value";
export import FieldValue = FieldValue.FieldValue;
import * as HealthInsuranceKvModelSubTypeDetails from "./health-insurance-kv-model-sub-type-details";
export import HealthInsuranceKvModelSubTypeDetails = HealthInsuranceKvModelSubTypeDetails.HealthInsuranceKvModelSubTypeDetails;
import * as InputLocation from "./input-location";
export import InputLocation = InputLocation.InputLocation;
import * as InvoiceKvModelSubTypeDetails from "./invoice-kv-model-sub-type-details";
export import InvoiceKvModelSubTypeDetails = InvoiceKvModelSubTypeDetails.InvoiceKvModelSubTypeDetails;
import * as KeyValueDetectionConfidenceEntry from "./key-value-detection-confidence-entry";
export import KeyValueDetectionConfidenceEntry = KeyValueDetectionConfidenceEntry.KeyValueDetectionConfidenceEntry;
import * as KeyValueDetectionLabelMetricsReport from "./key-value-detection-label-metrics-report";
export import KeyValueDetectionLabelMetricsReport = KeyValueDetectionLabelMetricsReport.KeyValueDetectionLabelMetricsReport;
import * as KeyValueDetectionOverallMetricsReport from "./key-value-detection-overall-metrics-report";
export import KeyValueDetectionOverallMetricsReport = KeyValueDetectionOverallMetricsReport.KeyValueDetectionOverallMetricsReport;
import * as Line from "./line";
export import Line = Line.Line;
import * as Model from "./model";
export import Model = Model.Model;
import * as ModelCollection from "./model-collection";
export import ModelCollection = ModelCollection.ModelCollection;
import * as ModelMetrics from "./model-metrics";
export import ModelMetrics = ModelMetrics.ModelMetrics;
import * as ModelSubType from "./model-sub-type";
export import ModelSubType = ModelSubType.ModelSubType;
import * as ModelSummary from "./model-summary";
export import ModelSummary = ModelSummary.ModelSummary;
import * as ModelTypeInfo from "./model-type-info";
export import ModelTypeInfo = ModelTypeInfo.ModelTypeInfo;
import * as NormalizationFields from "./normalization-fields";
export import NormalizationFields = NormalizationFields.NormalizationFields;
import * as NormalizationFieldsMapValue from "./normalization-fields-map-value";
export import NormalizationFieldsMapValue = NormalizationFieldsMapValue.NormalizationFieldsMapValue;
import * as NormalizedVertex from "./normalized-vertex";
export import NormalizedVertex = NormalizedVertex.NormalizedVertex;
import * as ObjectLocation from "./object-location";
export import ObjectLocation = ObjectLocation.ObjectLocation;
import * as OperationStatus from "./operation-status";
export import OperationStatus = OperationStatus.OperationStatus;
import * as OperationType from "./operation-type";
export import OperationType = OperationType.OperationType;
import * as OutputLocation from "./output-location";
export import OutputLocation = OutputLocation.OutputLocation;
import * as Page from "./page";
export import Page = Page.Page;
import * as PassportKvModelSubTypeDetails from "./passport-kv-model-sub-type-details";
export import PassportKvModelSubTypeDetails = PassportKvModelSubTypeDetails.PassportKvModelSubTypeDetails;
import * as PatchModelDetails from "./patch-model-details";
export import PatchModelDetails = PatchModelDetails.PatchModelDetails;
import * as PatchModelOperation from "./patch-model-operation";
export import PatchModelOperation = PatchModelOperation.PatchModelOperation;
import * as PatchResponseMessage from "./patch-response-message";
export import PatchResponseMessage = PatchResponseMessage.PatchResponseMessage;
import * as ProcessingError from "./processing-error";
export import ProcessingError = ProcessingError.ProcessingError;
import * as ProcessorConfig from "./processor-config";
export import ProcessorConfig = ProcessorConfig.ProcessorConfig;
import * as ProcessorJob from "./processor-job";
export import ProcessorJob = ProcessorJob.ProcessorJob;
import * as ProcessorType from "./processor-type";
export import ProcessorType = ProcessorType.ProcessorType;
import * as Project from "./project";
export import Project = Project.Project;
import * as ProjectCollection from "./project-collection";
export import ProjectCollection = ProjectCollection.ProjectCollection;
import * as ProjectSummary from "./project-summary";
export import ProjectSummary = ProjectSummary.ProjectSummary;
import * as QrBarCodeSubTypeDetails from "./qr-bar-code-sub-type-details";
export import QrBarCodeSubTypeDetails = QrBarCodeSubTypeDetails.QrBarCodeSubTypeDetails;
import * as ReceiptKvModelSubTypeDetails from "./receipt-kv-model-sub-type-details";
export import ReceiptKvModelSubTypeDetails = ReceiptKvModelSubTypeDetails.ReceiptKvModelSubTypeDetails;
import * as RemoveModelLockDetails from "./remove-model-lock-details";
export import RemoveModelLockDetails = RemoveModelLockDetails.RemoveModelLockDetails;
import * as RemoveProjectLockDetails from "./remove-project-lock-details";
export import RemoveProjectLockDetails = RemoveProjectLockDetails.RemoveProjectLockDetails;
import * as ResourceLock from "./resource-lock";
export import ResourceLock = ResourceLock.ResourceLock;
import * as SelectionMark from "./selection-mark";
export import SelectionMark = SelectionMark.SelectionMark;
import * as Signature from "./signature";
export import Signature = Signature.Signature;
import * as SignatureSubTypeDetails from "./signature-sub-type-details";
export import SignatureSubTypeDetails = SignatureSubTypeDetails.SignatureSubTypeDetails;
import * as SortOrder from "./sort-order";
export import SortOrder = SortOrder.SortOrder;
import * as Table from "./table";
export import Table = Table.Table;
import * as TableRow from "./table-row";
export import TableRow = TableRow.TableRow;
import * as UpdateModelDetails from "./update-model-details";
export import UpdateModelDetails = UpdateModelDetails.UpdateModelDetails;
import * as UpdateProjectDetails from "./update-project-details";
export import UpdateProjectDetails = UpdateProjectDetails.UpdateProjectDetails;
import * as Word from "./word";
export import Word = Word.Word;
import * as WorkRequest from "./work-request";
export import WorkRequest = WorkRequest.WorkRequest;
import * as WorkRequestError from "./work-request-error";
export import WorkRequestError = WorkRequestError.WorkRequestError;
import * as WorkRequestErrorCollection from "./work-request-error-collection";
export import WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
import * as WorkRequestLogEntry from "./work-request-log-entry";
export import WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
import * as WorkRequestLogEntryCollection from "./work-request-log-entry-collection";
export import WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
import * as WorkRequestResource from "./work-request-resource";
export import WorkRequestResource = WorkRequestResource.WorkRequestResource;
import * as WorkRequestResourceMetadataKey from "./work-request-resource-metadata-key";
export import WorkRequestResourceMetadataKey = WorkRequestResourceMetadataKey.WorkRequestResourceMetadataKey;
import * as WorkRequestSummary from "./work-request-summary";
export import WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
import * as WorkRequestSummaryCollection from "./work-request-summary-collection";
export import WorkRequestSummaryCollection = WorkRequestSummaryCollection.WorkRequestSummaryCollection;
import * as DataScienceLabelingDataset from "./data-science-labeling-dataset";
export import DataScienceLabelingDataset = DataScienceLabelingDataset.DataScienceLabelingDataset;
import * as DocumentClassificationFeature from "./document-classification-feature";
export import DocumentClassificationFeature = DocumentClassificationFeature.DocumentClassificationFeature;
import * as DocumentClassificationModelMetrics from "./document-classification-model-metrics";
export import DocumentClassificationModelMetrics = DocumentClassificationModelMetrics.DocumentClassificationModelMetrics;
import * as DocumentElementsExtractionFeature from "./document-elements-extraction-feature";
export import DocumentElementsExtractionFeature = DocumentElementsExtractionFeature.DocumentElementsExtractionFeature;
import * as DocumentElementsSubType from "./document-elements-sub-type";
export import DocumentElementsSubType = DocumentElementsSubType.DocumentElementsSubType;
import * as DocumentKeyValueExtractionFeature from "./document-key-value-extraction-feature";
export import DocumentKeyValueExtractionFeature = DocumentKeyValueExtractionFeature.DocumentKeyValueExtractionFeature;
import * as DocumentLanguageClassificationFeature from "./document-language-classification-feature";
export import DocumentLanguageClassificationFeature = DocumentLanguageClassificationFeature.DocumentLanguageClassificationFeature;
import * as DocumentTableExtractionFeature from "./document-table-extraction-feature";
export import DocumentTableExtractionFeature = DocumentTableExtractionFeature.DocumentTableExtractionFeature;
import * as DocumentTextExtractionFeature from "./document-text-extraction-feature";
export import DocumentTextExtractionFeature = DocumentTextExtractionFeature.DocumentTextExtractionFeature;
import * as GeneralProcessorConfig from "./general-processor-config";
export import GeneralProcessorConfig = GeneralProcessorConfig.GeneralProcessorConfig;
import * as InlineDocumentContent from "./inline-document-content";
export import InlineDocumentContent = InlineDocumentContent.InlineDocumentContent;
import * as InlineDocumentDetails from "./inline-document-details";
export import InlineDocumentDetails = InlineDocumentDetails.InlineDocumentDetails;
import * as InvoiceProcessorConfig from "./invoice-processor-config";
export import InvoiceProcessorConfig = InvoiceProcessorConfig.InvoiceProcessorConfig;
import * as KeyValueDetectionModelMetrics from "./key-value-detection-model-metrics";
export import KeyValueDetectionModelMetrics = KeyValueDetectionModelMetrics.KeyValueDetectionModelMetrics;
import * as KvModelSubType from "./kv-model-sub-type";
export import KvModelSubType = KvModelSubType.KvModelSubType;
import * as ObjectStorageDataset from "./object-storage-dataset";
export import ObjectStorageDataset = ObjectStorageDataset.ObjectStorageDataset;
import * as ObjectStorageDocumentDetails from "./object-storage-document-details";
export import ObjectStorageDocumentDetails = ObjectStorageDocumentDetails.ObjectStorageDocumentDetails;
import * as ObjectStorageLocations from "./object-storage-locations";
export import ObjectStorageLocations = ObjectStorageLocations.ObjectStorageLocations;
import * as PreTrainedDocumentElementsExtractionModelDetails from "./pre-trained-document-elements-extraction-model-details";
export import PreTrainedDocumentElementsExtractionModelDetails = PreTrainedDocumentElementsExtractionModelDetails.PreTrainedDocumentElementsExtractionModelDetails;
import * as PretrainedDocumentClassificationModelDetails from "./pretrained-document-classification-model-details";
export import PretrainedDocumentClassificationModelDetails = PretrainedDocumentClassificationModelDetails.PretrainedDocumentClassificationModelDetails;
import * as PretrainedKeyValueExtractionModelDetails from "./pretrained-key-value-extraction-model-details";
export import PretrainedKeyValueExtractionModelDetails = PretrainedKeyValueExtractionModelDetails.PretrainedKeyValueExtractionModelDetails;
import * as PretrainedTableExtractionModelDetails from "./pretrained-table-extraction-model-details";
export import PretrainedTableExtractionModelDetails = PretrainedTableExtractionModelDetails.PretrainedTableExtractionModelDetails;
import * as PretrainedTextExtractionModelDetails from "./pretrained-text-extraction-model-details";
export import PretrainedTextExtractionModelDetails = PretrainedTextExtractionModelDetails.PretrainedTextExtractionModelDetails;
import * as ValueArray from "./value-array";
export import ValueArray = ValueArray.ValueArray;
import * as ValueDate from "./value-date";
export import ValueDate = ValueDate.ValueDate;
import * as ValueInteger from "./value-integer";
export import ValueInteger = ValueInteger.ValueInteger;
import * as ValueNumber from "./value-number";
export import ValueNumber = ValueNumber.ValueNumber;
import * as ValuePhoneNumber from "./value-phone-number";
export import ValuePhoneNumber = ValuePhoneNumber.ValuePhoneNumber;
import * as ValueString from "./value-string";
export import ValueString = ValueString.ValueString;
import * as ValueTime from "./value-time";
export import ValueTime = ValueTime.ValueTime;
