/**
 * Document Understanding API
 * Document AI helps customers perform various analysis on their documents. If a customer has lots of documents, they can process them in batch using asynchronous API endpoints.
 * OpenAPI spec version: 20221109
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The Kv model sub type
 */
export interface KvModelSubType extends model.ModelSubType {
    /**
     * The model sub type for KEY_VALUE_EXTRACTION
     * The allowed values are:
     * - {@code RECEIPT}
     * - {@code INVOICE}
     * - {@code PASSPORT}
     * - {@code DRIVER_LICENSE}
     * - {@code HEALTH_INSURANCE_ID}
     *
     */
    "modelSubType": KvModelSubType.ModelSubType;
    "modelType": string;
}
export declare namespace KvModelSubType {
    enum ModelSubType {
        Receipt = "RECEIPT",
        Invoice = "INVOICE",
        Passport = "PASSPORT",
        DriverLicense = "DRIVER_LICENSE",
        HealthInsuranceId = "HEALTH_INSURANCE_ID",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: KvModelSubType, isParentJsonObj?: boolean): object;
    const modelType = "PRE_TRAINED_KEY_VALUE_EXTRACTION";
    function getDeserializedJsonObj(obj: KvModelSubType, isParentJsonObj?: boolean): object;
}
