/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details required to connect to a cloud Oracle Database.
 *
 */
export interface CloudDatabaseConnectionInfo extends model.CloudDbSystemConnectionInfo {
    "connectionString": model.DatabaseConnectionString;
    "connectionCredentials"?: model.DatabaseNamedCredentialConnectionDetails | model.DatabaseConnectionCredentailsByName | model.DatabaseSslConnectionCredentials | model.DatabaseConnectionCredentialsByDetails;
    "componentType": string;
}
export declare namespace CloudDatabaseConnectionInfo {
    function getJsonObj(obj: CloudDatabaseConnectionInfo, isParentJsonObj?: boolean): object;
    const componentType = "DATABASE";
    function getDeserializedJsonObj(obj: CloudDatabaseConnectionInfo, isParentJsonObj?: boolean): object;
}
