/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details of a cloud Pluggable Database (PDB) discovered in a cloud DB system discovery run.
 */
export interface DiscoveredCloudPluggableDatabase extends model.DiscoveredCloudDbSystemComponent {
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId": string;
    /**
     * The unique identifier of the parent Container Database (CDB).
     */
    "containerDatabaseId": string;
    /**
     * The unique identifier of the PDB.
     */
    "guid"?: string;
    "connector"?: model.CloudDbSystemDiscoveryMacsConnector;
    "componentType": string;
}
export declare namespace DiscoveredCloudPluggableDatabase {
    function getJsonObj(obj: DiscoveredCloudPluggableDatabase, isParentJsonObj?: boolean): object;
    const componentType = "PLUGGABLE_DATABASE";
    function getDeserializedJsonObj(obj: DiscoveredCloudPluggableDatabase, isParentJsonObj?: boolean): object;
}
