/**
 * Database Management API
 * Use the Database Management API to monitor and manage resources such as
Oracle Databases, MySQL Databases, and External Database Systems.
For more information, see [Database Management](https://docs.oracle.com/iaas/database-management/home.htm).

 * OpenAPI spec version: 20201101
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
 * The details of an Oracle DB instance discovered in an external DB system discovery run.
 */
export interface DiscoveredExternalDbInstance extends model.DiscoveredExternalDbSystemComponent {
    /**
     * The name of the DB instance.
     */
    "instanceName": string;
    /**
     * The name of the host on which the DB instance is running.
     */
    "hostName"?: string;
    /**
     * The name of the DB instance node.
     */
    "nodeName"?: string;
    /**
     * The Oracle home location of the DB instance.
     */
    "oracleHome"?: string;
    /**
     * The Automatic Diagnostic Repository (ADR) home directory for the DB instance.
     */
    "adrHomeDirectory"?: string;
    "componentType": string;
}
export declare namespace DiscoveredExternalDbInstance {
    function getJsonObj(obj: DiscoveredExternalDbInstance, isParentJsonObj?: boolean): object;
    const componentType = "DATABASE_INSTANCE";
    function getDeserializedJsonObj(obj: DiscoveredExternalDbInstance, isParentJsonObj?: boolean): object;
}
