/**
 * Oracle Database MultiCloud Data plane Integration
 * 1. Oracle Azure Connector Resource: This is for installing Azure Arc Server in ExaCS VM Cluster.
  There are two way to install Azure Arc Server (Azure Identity) in ExaCS VMCluster.
    a. Using Bearer Access Token or
    b. By providing Authentication token

2. Oracle Azure Blob Container Resource: This is for to capture Azure Container details
   and same will be used in multiple ExaCS VMCluster to mount the Azure Container.

3. Oracle Azure Blob Mount Resource: This is for to mount Azure Container in ExaCS VMCluster
   using Oracle Azure Connector and Oracle Azure Blob Container Resource.

 * OpenAPI spec version: 20240501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as requests from "./lib/request";
import * as models from "./lib/model";
import * as responses from "./lib/response";
import * as client from "./lib/client";
import * as multicloudresourcediscovery_waiter from "./lib/multicloudresourcediscovery-waiter";
import * as oracledbazureblobcontainer_waiter from "./lib/oracledbazureblobcontainer-waiter";
import * as oracledbazureblobmount_waiter from "./lib/oracledbazureblobmount-waiter";
import * as oracledbazureconnector_waiter from "./lib/oracledbazureconnector-waiter";
import * as oracledbazurekey_waiter from "./lib/oracledbazurekey-waiter";
import * as oracledbazurevault_waiter from "./lib/oracledbazurevault-waiter";
import * as oracledbazurevaultassociation_waiter from "./lib/oracledbazurevaultassociation-waiter";
import * as workrequest_waiter from "./lib/workrequest-waiter";
export { models };
export { requests };
export { responses };
export import MultiCloudResourceDiscoveryClient = client.MultiCloudResourceDiscoveryClient;
export import MultiCloudResourceDiscoveryWaiter = multicloudresourcediscovery_waiter.MultiCloudResourceDiscoveryWaiter;
export import OracleDBAzureBlobContainerClient = client.OracleDBAzureBlobContainerClient;
export import OracleDBAzureBlobContainerWaiter = oracledbazureblobcontainer_waiter.OracleDBAzureBlobContainerWaiter;
export import OracleDBAzureBlobMountClient = client.OracleDBAzureBlobMountClient;
export import OracleDBAzureBlobMountWaiter = oracledbazureblobmount_waiter.OracleDBAzureBlobMountWaiter;
export import OracleDBAzureConnectorClient = client.OracleDBAzureConnectorClient;
export import OracleDBAzureConnectorWaiter = oracledbazureconnector_waiter.OracleDBAzureConnectorWaiter;
export import OracleDbAzureKeyClient = client.OracleDbAzureKeyClient;
export import OracleDbAzureKeyWaiter = oracledbazurekey_waiter.OracleDbAzureKeyWaiter;
export import OracleDbAzureVaultClient = client.OracleDbAzureVaultClient;
export import OracleDbAzureVaultWaiter = oracledbazurevault_waiter.OracleDbAzureVaultWaiter;
export import OracleDbAzureVaultAssociationClient = client.OracleDbAzureVaultAssociationClient;
export import OracleDbAzureVaultAssociationWaiter = oracledbazurevaultassociation_waiter.OracleDbAzureVaultAssociationWaiter;
export import WorkRequestClient = client.WorkRequestClient;
export import WorkRequestWaiter = workrequest_waiter.WorkRequestWaiter;
