/**
 * Oracle Database MultiCloud Data plane Integration
 * 1. Oracle Azure Connector Resource: This is for installing Azure Arc Server in ExaCS VM Cluster.
  There are two way to install Azure Arc Server (Azure Identity) in ExaCS VMCluster.
    a. Using Bearer Access Token or
    b. By providing Authentication token

2. Oracle Azure Blob Container Resource: This is for to capture Azure Container details
   and same will be used in multiple ExaCS VMCluster to mount the Azure Container.

3. Oracle Azure Blob Mount Resource: This is for to mount Azure Container in ExaCS VMCluster
   using Oracle Azure Connector and Oracle Azure Blob Container Resource.

 * OpenAPI spec version: 20240501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as ActionType from "./action-type";
export import ActionType = ActionType.ActionType;
import * as ArcAgentNodes from "./arc-agent-nodes";
export import ArcAgentNodes = ArcAgentNodes.ArcAgentNodes;
import * as ChangeMultiCloudResourceDiscoveryCompartmentDetails from "./change-multi-cloud-resource-discovery-compartment-details";
export import ChangeMultiCloudResourceDiscoveryCompartmentDetails = ChangeMultiCloudResourceDiscoveryCompartmentDetails.ChangeMultiCloudResourceDiscoveryCompartmentDetails;
import * as ChangeOracleDbAzureBlobContainerCompartmentDetails from "./change-oracle-db-azure-blob-container-compartment-details";
export import ChangeOracleDbAzureBlobContainerCompartmentDetails = ChangeOracleDbAzureBlobContainerCompartmentDetails.ChangeOracleDbAzureBlobContainerCompartmentDetails;
import * as ChangeOracleDbAzureBlobMountCompartmentDetails from "./change-oracle-db-azure-blob-mount-compartment-details";
export import ChangeOracleDbAzureBlobMountCompartmentDetails = ChangeOracleDbAzureBlobMountCompartmentDetails.ChangeOracleDbAzureBlobMountCompartmentDetails;
import * as ChangeOracleDbAzureConnectorCompartmentDetails from "./change-oracle-db-azure-connector-compartment-details";
export import ChangeOracleDbAzureConnectorCompartmentDetails = ChangeOracleDbAzureConnectorCompartmentDetails.ChangeOracleDbAzureConnectorCompartmentDetails;
import * as ChangeOracleDbAzureVaultAssociationCompartmentDetails from "./change-oracle-db-azure-vault-association-compartment-details";
export import ChangeOracleDbAzureVaultAssociationCompartmentDetails = ChangeOracleDbAzureVaultAssociationCompartmentDetails.ChangeOracleDbAzureVaultAssociationCompartmentDetails;
import * as ChangeOracleDbAzureVaultCompartmentDetails from "./change-oracle-db-azure-vault-compartment-details";
export import ChangeOracleDbAzureVaultCompartmentDetails = ChangeOracleDbAzureVaultCompartmentDetails.ChangeOracleDbAzureVaultCompartmentDetails;
import * as CreateMultiCloudResourceDiscoveryDetails from "./create-multi-cloud-resource-discovery-details";
export import CreateMultiCloudResourceDiscoveryDetails = CreateMultiCloudResourceDiscoveryDetails.CreateMultiCloudResourceDiscoveryDetails;
import * as CreateOracleDbAzureBlobContainerDetails from "./create-oracle-db-azure-blob-container-details";
export import CreateOracleDbAzureBlobContainerDetails = CreateOracleDbAzureBlobContainerDetails.CreateOracleDbAzureBlobContainerDetails;
import * as CreateOracleDbAzureBlobMountDetails from "./create-oracle-db-azure-blob-mount-details";
export import CreateOracleDbAzureBlobMountDetails = CreateOracleDbAzureBlobMountDetails.CreateOracleDbAzureBlobMountDetails;
import * as CreateOracleDbAzureConnectorDetails from "./create-oracle-db-azure-connector-details";
export import CreateOracleDbAzureConnectorDetails = CreateOracleDbAzureConnectorDetails.CreateOracleDbAzureConnectorDetails;
import * as CreateOracleDbAzureVaultAssociationDetails from "./create-oracle-db-azure-vault-association-details";
export import CreateOracleDbAzureVaultAssociationDetails = CreateOracleDbAzureVaultAssociationDetails.CreateOracleDbAzureVaultAssociationDetails;
import * as CreateOracleDbAzureVaultDetails from "./create-oracle-db-azure-vault-details";
export import CreateOracleDbAzureVaultDetails = CreateOracleDbAzureVaultDetails.CreateOracleDbAzureVaultDetails;
import * as MultiCloudResourceDiscovery from "./multi-cloud-resource-discovery";
export import MultiCloudResourceDiscovery = MultiCloudResourceDiscovery.MultiCloudResourceDiscovery;
import * as MultiCloudResourceDiscoverySummary from "./multi-cloud-resource-discovery-summary";
export import MultiCloudResourceDiscoverySummary = MultiCloudResourceDiscoverySummary.MultiCloudResourceDiscoverySummary;
import * as MultiCloudResourceDiscoverySummaryCollection from "./multi-cloud-resource-discovery-summary-collection";
export import MultiCloudResourceDiscoverySummaryCollection = MultiCloudResourceDiscoverySummaryCollection.MultiCloudResourceDiscoverySummaryCollection;
import * as OperationStatus from "./operation-status";
export import OperationStatus = OperationStatus.OperationStatus;
import * as OperationType from "./operation-type";
export import OperationType = OperationType.OperationType;
import * as OracleDbAzureBlobContainer from "./oracle-db-azure-blob-container";
export import OracleDbAzureBlobContainer = OracleDbAzureBlobContainer.OracleDbAzureBlobContainer;
import * as OracleDbAzureBlobContainerSummary from "./oracle-db-azure-blob-container-summary";
export import OracleDbAzureBlobContainerSummary = OracleDbAzureBlobContainerSummary.OracleDbAzureBlobContainerSummary;
import * as OracleDbAzureBlobContainerSummaryCollection from "./oracle-db-azure-blob-container-summary-collection";
export import OracleDbAzureBlobContainerSummaryCollection = OracleDbAzureBlobContainerSummaryCollection.OracleDbAzureBlobContainerSummaryCollection;
import * as OracleDbAzureBlobMount from "./oracle-db-azure-blob-mount";
export import OracleDbAzureBlobMount = OracleDbAzureBlobMount.OracleDbAzureBlobMount;
import * as OracleDbAzureBlobMountSummary from "./oracle-db-azure-blob-mount-summary";
export import OracleDbAzureBlobMountSummary = OracleDbAzureBlobMountSummary.OracleDbAzureBlobMountSummary;
import * as OracleDbAzureBlobMountSummaryCollection from "./oracle-db-azure-blob-mount-summary-collection";
export import OracleDbAzureBlobMountSummaryCollection = OracleDbAzureBlobMountSummaryCollection.OracleDbAzureBlobMountSummaryCollection;
import * as OracleDbAzureConnector from "./oracle-db-azure-connector";
export import OracleDbAzureConnector = OracleDbAzureConnector.OracleDbAzureConnector;
import * as OracleDbAzureConnectorSummary from "./oracle-db-azure-connector-summary";
export import OracleDbAzureConnectorSummary = OracleDbAzureConnectorSummary.OracleDbAzureConnectorSummary;
import * as OracleDbAzureConnectorSummaryCollection from "./oracle-db-azure-connector-summary-collection";
export import OracleDbAzureConnectorSummaryCollection = OracleDbAzureConnectorSummaryCollection.OracleDbAzureConnectorSummaryCollection;
import * as OracleDbAzureKey from "./oracle-db-azure-key";
export import OracleDbAzureKey = OracleDbAzureKey.OracleDbAzureKey;
import * as OracleDbAzureKeySummary from "./oracle-db-azure-key-summary";
export import OracleDbAzureKeySummary = OracleDbAzureKeySummary.OracleDbAzureKeySummary;
import * as OracleDbAzureKeySummaryCollection from "./oracle-db-azure-key-summary-collection";
export import OracleDbAzureKeySummaryCollection = OracleDbAzureKeySummaryCollection.OracleDbAzureKeySummaryCollection;
import * as OracleDbAzureVault from "./oracle-db-azure-vault";
export import OracleDbAzureVault = OracleDbAzureVault.OracleDbAzureVault;
import * as OracleDbAzureVaultAssociation from "./oracle-db-azure-vault-association";
export import OracleDbAzureVaultAssociation = OracleDbAzureVaultAssociation.OracleDbAzureVaultAssociation;
import * as OracleDbAzureVaultAssociationSummary from "./oracle-db-azure-vault-association-summary";
export import OracleDbAzureVaultAssociationSummary = OracleDbAzureVaultAssociationSummary.OracleDbAzureVaultAssociationSummary;
import * as OracleDbAzureVaultAssociationSummaryCollection from "./oracle-db-azure-vault-association-summary-collection";
export import OracleDbAzureVaultAssociationSummaryCollection = OracleDbAzureVaultAssociationSummaryCollection.OracleDbAzureVaultAssociationSummaryCollection;
import * as OracleDbAzureVaultSummary from "./oracle-db-azure-vault-summary";
export import OracleDbAzureVaultSummary = OracleDbAzureVaultSummary.OracleDbAzureVaultSummary;
import * as OracleDbAzureVaultSummaryCollection from "./oracle-db-azure-vault-summary-collection";
export import OracleDbAzureVaultSummaryCollection = OracleDbAzureVaultSummaryCollection.OracleDbAzureVaultSummaryCollection;
import * as PatchOracleDbAzureConnectorDetails from "./patch-oracle-db-azure-connector-details";
export import PatchOracleDbAzureConnectorDetails = PatchOracleDbAzureConnectorDetails.PatchOracleDbAzureConnectorDetails;
import * as Resources from "./resources";
export import Resources = Resources.Resources;
import * as SortOrder from "./sort-order";
export import SortOrder = SortOrder.SortOrder;
import * as UpdateMultiCloudResourceDiscoveryDetails from "./update-multi-cloud-resource-discovery-details";
export import UpdateMultiCloudResourceDiscoveryDetails = UpdateMultiCloudResourceDiscoveryDetails.UpdateMultiCloudResourceDiscoveryDetails;
import * as UpdateOracleDbAzureBlobContainerDetails from "./update-oracle-db-azure-blob-container-details";
export import UpdateOracleDbAzureBlobContainerDetails = UpdateOracleDbAzureBlobContainerDetails.UpdateOracleDbAzureBlobContainerDetails;
import * as UpdateOracleDbAzureBlobMountDetails from "./update-oracle-db-azure-blob-mount-details";
export import UpdateOracleDbAzureBlobMountDetails = UpdateOracleDbAzureBlobMountDetails.UpdateOracleDbAzureBlobMountDetails;
import * as UpdateOracleDbAzureConnectorDetails from "./update-oracle-db-azure-connector-details";
export import UpdateOracleDbAzureConnectorDetails = UpdateOracleDbAzureConnectorDetails.UpdateOracleDbAzureConnectorDetails;
import * as UpdateOracleDbAzureVaultAssociationDetails from "./update-oracle-db-azure-vault-association-details";
export import UpdateOracleDbAzureVaultAssociationDetails = UpdateOracleDbAzureVaultAssociationDetails.UpdateOracleDbAzureVaultAssociationDetails;
import * as UpdateOracleDbAzureVaultDetails from "./update-oracle-db-azure-vault-details";
export import UpdateOracleDbAzureVaultDetails = UpdateOracleDbAzureVaultDetails.UpdateOracleDbAzureVaultDetails;
import * as WorkRequest from "./work-request";
export import WorkRequest = WorkRequest.WorkRequest;
import * as WorkRequestError from "./work-request-error";
export import WorkRequestError = WorkRequestError.WorkRequestError;
import * as WorkRequestErrorCollection from "./work-request-error-collection";
export import WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
import * as WorkRequestLogEntry from "./work-request-log-entry";
export import WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
import * as WorkRequestLogEntryCollection from "./work-request-log-entry-collection";
export import WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
import * as WorkRequestResource from "./work-request-resource";
export import WorkRequestResource = WorkRequestResource.WorkRequestResource;
import * as WorkRequestResourceMetadataKey from "./work-request-resource-metadata-key";
export import WorkRequestResourceMetadataKey = WorkRequestResourceMetadataKey.WorkRequestResourceMetadataKey;
import * as WorkRequestSummary from "./work-request-summary";
export import WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
import * as WorkRequestSummaryCollection from "./work-request-summary-collection";
export import WorkRequestSummaryCollection = WorkRequestSummaryCollection.WorkRequestSummaryCollection;
