"use strict";
/**
 * Oracle Database MultiCloud Data plane Integration
 * 1. Oracle Azure Connector Resource: This is for installing Azure Arc Server in ExaCS VM Cluster.
  There are two way to install Azure Arc Server (Azure Identity) in ExaCS VMCluster.
    a. Using Bearer Access Token or
    b. By providing Authentication token

2. Oracle Azure Blob Container Resource: This is for to capture Azure Container details
   and same will be used in multiple ExaCS VMCluster to mount the Azure Container.

3. Oracle Azure Blob Mount Resource: This is for to mount Azure Container in ExaCS VMCluster
   using Oracle Azure Connector and Oracle Azure Blob Container Resource.

 * OpenAPI spec version: 20240501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkRequestLogEntry = exports.WorkRequestErrorCollection = exports.WorkRequestError = exports.WorkRequest = exports.UpdateOracleDbAzureVaultDetails = exports.UpdateOracleDbAzureVaultAssociationDetails = exports.UpdateOracleDbAzureConnectorDetails = exports.UpdateOracleDbAzureBlobMountDetails = exports.UpdateOracleDbAzureBlobContainerDetails = exports.UpdateMultiCloudResourceDiscoveryDetails = exports.SortOrder = exports.Resources = exports.PatchOracleDbAzureConnectorDetails = exports.OracleDbAzureVaultSummaryCollection = exports.OracleDbAzureVaultSummary = exports.OracleDbAzureVaultAssociationSummaryCollection = exports.OracleDbAzureVaultAssociationSummary = exports.OracleDbAzureVaultAssociation = exports.OracleDbAzureVault = exports.OracleDbAzureKeySummaryCollection = exports.OracleDbAzureKeySummary = exports.OracleDbAzureKey = exports.OracleDbAzureConnectorSummaryCollection = exports.OracleDbAzureConnectorSummary = exports.OracleDbAzureConnector = exports.OracleDbAzureBlobMountSummaryCollection = exports.OracleDbAzureBlobMountSummary = exports.OracleDbAzureBlobMount = exports.OracleDbAzureBlobContainerSummaryCollection = exports.OracleDbAzureBlobContainerSummary = exports.OracleDbAzureBlobContainer = exports.OperationType = exports.OperationStatus = exports.MultiCloudResourceDiscoverySummaryCollection = exports.MultiCloudResourceDiscoverySummary = exports.MultiCloudResourceDiscovery = exports.CreateOracleDbAzureVaultDetails = exports.CreateOracleDbAzureVaultAssociationDetails = exports.CreateOracleDbAzureConnectorDetails = exports.CreateOracleDbAzureBlobMountDetails = exports.CreateOracleDbAzureBlobContainerDetails = exports.CreateMultiCloudResourceDiscoveryDetails = exports.ChangeOracleDbAzureVaultCompartmentDetails = exports.ChangeOracleDbAzureVaultAssociationCompartmentDetails = exports.ChangeOracleDbAzureConnectorCompartmentDetails = exports.ChangeOracleDbAzureBlobMountCompartmentDetails = exports.ChangeOracleDbAzureBlobContainerCompartmentDetails = exports.ChangeMultiCloudResourceDiscoveryCompartmentDetails = exports.ArcAgentNodes = exports.ActionType = void 0;
exports.WorkRequestSummaryCollection = exports.WorkRequestSummary = exports.WorkRequestResourceMetadataKey = exports.WorkRequestResource = exports.WorkRequestLogEntryCollection = void 0;
const ActionType = __importStar(require("./action-type"));
exports.ActionType = ActionType.ActionType;
const ArcAgentNodes = __importStar(require("./arc-agent-nodes"));
exports.ArcAgentNodes = ArcAgentNodes.ArcAgentNodes;
const ChangeMultiCloudResourceDiscoveryCompartmentDetails = __importStar(require("./change-multi-cloud-resource-discovery-compartment-details"));
exports.ChangeMultiCloudResourceDiscoveryCompartmentDetails = ChangeMultiCloudResourceDiscoveryCompartmentDetails.ChangeMultiCloudResourceDiscoveryCompartmentDetails;
const ChangeOracleDbAzureBlobContainerCompartmentDetails = __importStar(require("./change-oracle-db-azure-blob-container-compartment-details"));
exports.ChangeOracleDbAzureBlobContainerCompartmentDetails = ChangeOracleDbAzureBlobContainerCompartmentDetails.ChangeOracleDbAzureBlobContainerCompartmentDetails;
const ChangeOracleDbAzureBlobMountCompartmentDetails = __importStar(require("./change-oracle-db-azure-blob-mount-compartment-details"));
exports.ChangeOracleDbAzureBlobMountCompartmentDetails = ChangeOracleDbAzureBlobMountCompartmentDetails.ChangeOracleDbAzureBlobMountCompartmentDetails;
const ChangeOracleDbAzureConnectorCompartmentDetails = __importStar(require("./change-oracle-db-azure-connector-compartment-details"));
exports.ChangeOracleDbAzureConnectorCompartmentDetails = ChangeOracleDbAzureConnectorCompartmentDetails.ChangeOracleDbAzureConnectorCompartmentDetails;
const ChangeOracleDbAzureVaultAssociationCompartmentDetails = __importStar(require("./change-oracle-db-azure-vault-association-compartment-details"));
exports.ChangeOracleDbAzureVaultAssociationCompartmentDetails = ChangeOracleDbAzureVaultAssociationCompartmentDetails.ChangeOracleDbAzureVaultAssociationCompartmentDetails;
const ChangeOracleDbAzureVaultCompartmentDetails = __importStar(require("./change-oracle-db-azure-vault-compartment-details"));
exports.ChangeOracleDbAzureVaultCompartmentDetails = ChangeOracleDbAzureVaultCompartmentDetails.ChangeOracleDbAzureVaultCompartmentDetails;
const CreateMultiCloudResourceDiscoveryDetails = __importStar(require("./create-multi-cloud-resource-discovery-details"));
exports.CreateMultiCloudResourceDiscoveryDetails = CreateMultiCloudResourceDiscoveryDetails.CreateMultiCloudResourceDiscoveryDetails;
const CreateOracleDbAzureBlobContainerDetails = __importStar(require("./create-oracle-db-azure-blob-container-details"));
exports.CreateOracleDbAzureBlobContainerDetails = CreateOracleDbAzureBlobContainerDetails.CreateOracleDbAzureBlobContainerDetails;
const CreateOracleDbAzureBlobMountDetails = __importStar(require("./create-oracle-db-azure-blob-mount-details"));
exports.CreateOracleDbAzureBlobMountDetails = CreateOracleDbAzureBlobMountDetails.CreateOracleDbAzureBlobMountDetails;
const CreateOracleDbAzureConnectorDetails = __importStar(require("./create-oracle-db-azure-connector-details"));
exports.CreateOracleDbAzureConnectorDetails = CreateOracleDbAzureConnectorDetails.CreateOracleDbAzureConnectorDetails;
const CreateOracleDbAzureVaultAssociationDetails = __importStar(require("./create-oracle-db-azure-vault-association-details"));
exports.CreateOracleDbAzureVaultAssociationDetails = CreateOracleDbAzureVaultAssociationDetails.CreateOracleDbAzureVaultAssociationDetails;
const CreateOracleDbAzureVaultDetails = __importStar(require("./create-oracle-db-azure-vault-details"));
exports.CreateOracleDbAzureVaultDetails = CreateOracleDbAzureVaultDetails.CreateOracleDbAzureVaultDetails;
const MultiCloudResourceDiscovery = __importStar(require("./multi-cloud-resource-discovery"));
exports.MultiCloudResourceDiscovery = MultiCloudResourceDiscovery.MultiCloudResourceDiscovery;
const MultiCloudResourceDiscoverySummary = __importStar(require("./multi-cloud-resource-discovery-summary"));
exports.MultiCloudResourceDiscoverySummary = MultiCloudResourceDiscoverySummary.MultiCloudResourceDiscoverySummary;
const MultiCloudResourceDiscoverySummaryCollection = __importStar(require("./multi-cloud-resource-discovery-summary-collection"));
exports.MultiCloudResourceDiscoverySummaryCollection = MultiCloudResourceDiscoverySummaryCollection.MultiCloudResourceDiscoverySummaryCollection;
const OperationStatus = __importStar(require("./operation-status"));
exports.OperationStatus = OperationStatus.OperationStatus;
const OperationType = __importStar(require("./operation-type"));
exports.OperationType = OperationType.OperationType;
const OracleDbAzureBlobContainer = __importStar(require("./oracle-db-azure-blob-container"));
exports.OracleDbAzureBlobContainer = OracleDbAzureBlobContainer.OracleDbAzureBlobContainer;
const OracleDbAzureBlobContainerSummary = __importStar(require("./oracle-db-azure-blob-container-summary"));
exports.OracleDbAzureBlobContainerSummary = OracleDbAzureBlobContainerSummary.OracleDbAzureBlobContainerSummary;
const OracleDbAzureBlobContainerSummaryCollection = __importStar(require("./oracle-db-azure-blob-container-summary-collection"));
exports.OracleDbAzureBlobContainerSummaryCollection = OracleDbAzureBlobContainerSummaryCollection.OracleDbAzureBlobContainerSummaryCollection;
const OracleDbAzureBlobMount = __importStar(require("./oracle-db-azure-blob-mount"));
exports.OracleDbAzureBlobMount = OracleDbAzureBlobMount.OracleDbAzureBlobMount;
const OracleDbAzureBlobMountSummary = __importStar(require("./oracle-db-azure-blob-mount-summary"));
exports.OracleDbAzureBlobMountSummary = OracleDbAzureBlobMountSummary.OracleDbAzureBlobMountSummary;
const OracleDbAzureBlobMountSummaryCollection = __importStar(require("./oracle-db-azure-blob-mount-summary-collection"));
exports.OracleDbAzureBlobMountSummaryCollection = OracleDbAzureBlobMountSummaryCollection.OracleDbAzureBlobMountSummaryCollection;
const OracleDbAzureConnector = __importStar(require("./oracle-db-azure-connector"));
exports.OracleDbAzureConnector = OracleDbAzureConnector.OracleDbAzureConnector;
const OracleDbAzureConnectorSummary = __importStar(require("./oracle-db-azure-connector-summary"));
exports.OracleDbAzureConnectorSummary = OracleDbAzureConnectorSummary.OracleDbAzureConnectorSummary;
const OracleDbAzureConnectorSummaryCollection = __importStar(require("./oracle-db-azure-connector-summary-collection"));
exports.OracleDbAzureConnectorSummaryCollection = OracleDbAzureConnectorSummaryCollection.OracleDbAzureConnectorSummaryCollection;
const OracleDbAzureKey = __importStar(require("./oracle-db-azure-key"));
exports.OracleDbAzureKey = OracleDbAzureKey.OracleDbAzureKey;
const OracleDbAzureKeySummary = __importStar(require("./oracle-db-azure-key-summary"));
exports.OracleDbAzureKeySummary = OracleDbAzureKeySummary.OracleDbAzureKeySummary;
const OracleDbAzureKeySummaryCollection = __importStar(require("./oracle-db-azure-key-summary-collection"));
exports.OracleDbAzureKeySummaryCollection = OracleDbAzureKeySummaryCollection.OracleDbAzureKeySummaryCollection;
const OracleDbAzureVault = __importStar(require("./oracle-db-azure-vault"));
exports.OracleDbAzureVault = OracleDbAzureVault.OracleDbAzureVault;
const OracleDbAzureVaultAssociation = __importStar(require("./oracle-db-azure-vault-association"));
exports.OracleDbAzureVaultAssociation = OracleDbAzureVaultAssociation.OracleDbAzureVaultAssociation;
const OracleDbAzureVaultAssociationSummary = __importStar(require("./oracle-db-azure-vault-association-summary"));
exports.OracleDbAzureVaultAssociationSummary = OracleDbAzureVaultAssociationSummary.OracleDbAzureVaultAssociationSummary;
const OracleDbAzureVaultAssociationSummaryCollection = __importStar(require("./oracle-db-azure-vault-association-summary-collection"));
exports.OracleDbAzureVaultAssociationSummaryCollection = OracleDbAzureVaultAssociationSummaryCollection.OracleDbAzureVaultAssociationSummaryCollection;
const OracleDbAzureVaultSummary = __importStar(require("./oracle-db-azure-vault-summary"));
exports.OracleDbAzureVaultSummary = OracleDbAzureVaultSummary.OracleDbAzureVaultSummary;
const OracleDbAzureVaultSummaryCollection = __importStar(require("./oracle-db-azure-vault-summary-collection"));
exports.OracleDbAzureVaultSummaryCollection = OracleDbAzureVaultSummaryCollection.OracleDbAzureVaultSummaryCollection;
const PatchOracleDbAzureConnectorDetails = __importStar(require("./patch-oracle-db-azure-connector-details"));
exports.PatchOracleDbAzureConnectorDetails = PatchOracleDbAzureConnectorDetails.PatchOracleDbAzureConnectorDetails;
const Resources = __importStar(require("./resources"));
exports.Resources = Resources.Resources;
const SortOrder = __importStar(require("./sort-order"));
exports.SortOrder = SortOrder.SortOrder;
const UpdateMultiCloudResourceDiscoveryDetails = __importStar(require("./update-multi-cloud-resource-discovery-details"));
exports.UpdateMultiCloudResourceDiscoveryDetails = UpdateMultiCloudResourceDiscoveryDetails.UpdateMultiCloudResourceDiscoveryDetails;
const UpdateOracleDbAzureBlobContainerDetails = __importStar(require("./update-oracle-db-azure-blob-container-details"));
exports.UpdateOracleDbAzureBlobContainerDetails = UpdateOracleDbAzureBlobContainerDetails.UpdateOracleDbAzureBlobContainerDetails;
const UpdateOracleDbAzureBlobMountDetails = __importStar(require("./update-oracle-db-azure-blob-mount-details"));
exports.UpdateOracleDbAzureBlobMountDetails = UpdateOracleDbAzureBlobMountDetails.UpdateOracleDbAzureBlobMountDetails;
const UpdateOracleDbAzureConnectorDetails = __importStar(require("./update-oracle-db-azure-connector-details"));
exports.UpdateOracleDbAzureConnectorDetails = UpdateOracleDbAzureConnectorDetails.UpdateOracleDbAzureConnectorDetails;
const UpdateOracleDbAzureVaultAssociationDetails = __importStar(require("./update-oracle-db-azure-vault-association-details"));
exports.UpdateOracleDbAzureVaultAssociationDetails = UpdateOracleDbAzureVaultAssociationDetails.UpdateOracleDbAzureVaultAssociationDetails;
const UpdateOracleDbAzureVaultDetails = __importStar(require("./update-oracle-db-azure-vault-details"));
exports.UpdateOracleDbAzureVaultDetails = UpdateOracleDbAzureVaultDetails.UpdateOracleDbAzureVaultDetails;
const WorkRequest = __importStar(require("./work-request"));
exports.WorkRequest = WorkRequest.WorkRequest;
const WorkRequestError = __importStar(require("./work-request-error"));
exports.WorkRequestError = WorkRequestError.WorkRequestError;
const WorkRequestErrorCollection = __importStar(require("./work-request-error-collection"));
exports.WorkRequestErrorCollection = WorkRequestErrorCollection.WorkRequestErrorCollection;
const WorkRequestLogEntry = __importStar(require("./work-request-log-entry"));
exports.WorkRequestLogEntry = WorkRequestLogEntry.WorkRequestLogEntry;
const WorkRequestLogEntryCollection = __importStar(require("./work-request-log-entry-collection"));
exports.WorkRequestLogEntryCollection = WorkRequestLogEntryCollection.WorkRequestLogEntryCollection;
const WorkRequestResource = __importStar(require("./work-request-resource"));
exports.WorkRequestResource = WorkRequestResource.WorkRequestResource;
const WorkRequestResourceMetadataKey = __importStar(require("./work-request-resource-metadata-key"));
exports.WorkRequestResourceMetadataKey = WorkRequestResourceMetadataKey.WorkRequestResourceMetadataKey;
const WorkRequestSummary = __importStar(require("./work-request-summary"));
exports.WorkRequestSummary = WorkRequestSummary.WorkRequestSummary;
const WorkRequestSummaryCollection = __importStar(require("./work-request-summary-collection"));
exports.WorkRequestSummaryCollection = WorkRequestSummaryCollection.WorkRequestSummaryCollection;
//# sourceMappingURL=index.js.map