/**
 * Oracle Database MultiCloud Data plane Integration
 * 1. Oracle Azure Connector Resource: This is for installing Azure Arc Server in ExaCS VM Cluster.
  There are two way to install Azure Arc Server (Azure Identity) in ExaCS VMCluster.
    a. Using Bearer Access Token or
    b. By providing Authentication token

2. Oracle Azure Blob Container Resource: This is for to capture Azure Container details
   and same will be used in multiple ExaCS VMCluster to mount the Azure Container.

3. Oracle Azure Blob Mount Resource: This is for to mount Azure Container in ExaCS VMCluster
   using Oracle Azure Connector and Oracle Azure Blob Container Resource.

 * OpenAPI spec version: 20240501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
/**
 * Possible operation types.
 **/
export declare enum OperationType {
    CreateAzureConnector = "CREATE_AZURE_CONNECTOR",
    DeleteAzureConnector = "DELETE_AZURE_CONNECTOR",
    UpdateAzureConnector = "UPDATE_AZURE_CONNECTOR",
    MoveAzureConnector = "MOVE_AZURE_CONNECTOR",
    CreateAzureBlobContainer = "CREATE_AZURE_BLOB_CONTAINER",
    DeleteAzureBlobContainer = "DELETE_AZURE_BLOB_CONTAINER",
    UpdateAzureBlobContainer = "UPDATE_AZURE_BLOB_CONTAINER",
    MoveAzureBlobContainer = "MOVE_AZURE_BLOB_CONTAINER",
    CreateAzureBlobMount = "CREATE_AZURE_BLOB_MOUNT",
    MoveAzureBlobMount = "MOVE_AZURE_BLOB_MOUNT",
    UpdateAzureBlobMount = "UPDATE_AZURE_BLOB_MOUNT",
    DeleteAzureBlobMount = "DELETE_AZURE_BLOB_MOUNT",
    CreateMulticloudDiscovery = "CREATE_MULTICLOUD_DISCOVERY",
    DeleteMulticloudDiscovery = "DELETE_MULTICLOUD_DISCOVERY",
    UpdateMulticloudDiscovery = "UPDATE_MULTICLOUD_DISCOVERY",
    MoveMulticloudDiscovery = "MOVE_MULTICLOUD_DISCOVERY",
    CreateAzureVault = "CREATE_AZURE_VAULT",
    DeleteAzureVault = "DELETE_AZURE_VAULT",
    UpdateAzureVault = "UPDATE_AZURE_VAULT",
    MoveAzureVault = "MOVE_AZURE_VAULT",
    RefreshAzureVault = "REFRESH_AZURE_VAULT",
    CreateAzureVaultAssociation = "CREATE_AZURE_VAULT_ASSOCIATION",
    DeleteAzureVaultAssociation = "DELETE_AZURE_VAULT_ASSOCIATION",
    UpdateAzureVaultAssociation = "UPDATE_AZURE_VAULT_ASSOCIATION",
    MoveAzureVaultAssociation = "MOVE_AZURE_VAULT_ASSOCIATION",
    PatchDbResource = "PATCH_DB_RESOURCE",
    CreateGcpIdentityConfiguration = "CREATE_GCP_IDENTITY_CONFIGURATION",
    /**
     * This value is used if a service returns a value for this enum that is not recognized by this
     * version of the SDK.
     */
    UnknownValue = "UNKNOWN_VALUE"
}
export declare namespace OperationType {
    function getJsonObj(obj: OperationType): OperationType;
    function getDeserializedJsonObj(obj: OperationType): OperationType;
}
