/**
 *
 *
 * OpenAPI spec version: 20240501
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
import common = require("oci-common");
/**
 * @example Click {@link https://docs.oracle.com/en-us/iaas/tools/typescript-sdk-examples/latest/dbmulticloud/ListMultiCloudResourceDiscoveries.ts.html |here} to see how to use ListMultiCloudResourceDiscoveriesRequest.
 */
export interface ListMultiCloudResourceDiscoveriesRequest extends common.BaseRequest {
    /**
     * The [ID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the compartment.
     */
    "compartmentId": string;
    /**
     * Display Name of the Multi Cloud Discovery Resource.
     */
    "displayName"?: string;
    /**
     * The [OCID](https://docs.oracle.com/iaas/Content/General/Concepts/identifiers.htm) of the Multi Cloud Discovery Resource.
     */
    "multiCloudResourceDiscoveryId"?: string;
    /**
     * A filter to return only resources that match the given lifecycle state. The
     * state value is case-insensitive.
     *
     */
    "lifecycleState"?: string;
    /**
     * A filter to return Oracle DB Azure Blob Mount Resources.
     */
    "oracleDbAzureConnectorId"?: string;
    /**
     * The type of Multi Cloud Resource.
     */
    "resourceType"?: string;
    /**
     * The maximum number of items to return.
     */
    "limit"?: number;
    /**
     * The page token representing the page at which to start retrieving results. This is usually retrieved from a previous list call.
     */
    "page"?: string;
    /**
     * The sort order to use, either 'asc' or 'desc'.
     */
    "sortOrder"?: model.SortOrder;
    /**
     * The field to sort by. Only one sort order may be provided. Default order for timeCreated is descending. Default order for displayName is ascending. If no value is specified, default is timeCreated.
     *
     */
    "sortBy"?: ListMultiCloudResourceDiscoveriesRequest.SortBy;
    /**
     * The client request ID for tracing.
     */
    "opcRequestId"?: string;
}
export declare namespace ListMultiCloudResourceDiscoveriesRequest {
    enum SortBy {
        TimeCreated = "timeCreated",
        DisplayName = "displayName"
    }
}
