/**
 * Generative AI Agents Management API
 * OCI Generative AI Agents is a fully managed service that combines the power of large language models (LLMs) with an intelligent retrieval system to create contextually relevant answers by searching your knowledge base, making your AI applications smart and efficient.

OCI Generative AI Agents supports several ways to onboard your data and then allows you and your customers to interact with your data using a chat interface or API.

Use the Generative AI Agents API to create and manage agents, knowledge bases, data sources, endpoints, data ingestion jobs, and work requests.

For creating and managing client chat sessions see the {@link #eNGenerative-ai-agents-clientLatest(ENGenerative-ai-agents-clientLatestRequest) eNGenerative-ai-agents-clientLatest}.

To learn more about the service, see the [Generative AI Agents documentation](https://docs.oracle.com/iaas/Content/generative-ai-agents/home.htm).

 * OpenAPI spec version: 20240531
 *
 *
 * NOTE: This class is auto generated by OracleSDKGenerator.
 * Do not edit the class manually.
 *
 * Copyright (c) 2020, 2025, Oracle and/or its affiliates.  All rights reserved.
 * This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
 */
import * as model from "../model";
/**
* Specifies authentication using an API key injected either as a header or query parameter.
* <p>
- If {@code authScope = AGENT}: The API key is retrieved from OCI Vault using the agent\u2019s identity.
*
*/
export interface HttpEndpointApiKeyAuthScopeConfig extends model.HttpEndpointAuthScopeConfig {
    /**
     * The OCID of the vault secret with API key.
     * Required when {@code authScope} is AGENT.
     *
     */
    "vaultSecretId"?: string;
    /**
     * The location of the API key in the request.
     */
    "keyLocation": HttpEndpointApiKeyAuthScopeConfig.KeyLocation;
    /**
     * The name of the key parameter in the location.
     */
    "keyName": string;
    "httpEndpointAuthScopeConfigType": string;
}
export declare namespace HttpEndpointApiKeyAuthScopeConfig {
    enum KeyLocation {
        Header = "HEADER",
        QueryParameter = "QUERY_PARAMETER",
        /**
         * This value is used if a service returns a value for this enum that is not recognized by this
         * version of the SDK.
         */
        UnknownValue = "UNKNOWN_VALUE"
    }
    function getJsonObj(obj: HttpEndpointApiKeyAuthScopeConfig, isParentJsonObj?: boolean): object;
    const httpEndpointAuthScopeConfigType = "HTTP_ENDPOINT_API_KEY_AUTH_SCOPE_CONFIG";
    function getDeserializedJsonObj(obj: HttpEndpointApiKeyAuthScopeConfig, isParentJsonObj?: boolean): object;
}
